# Praktikumsblatt 7 - InfluxDB 2.1 + Flux
 

## Aufgabe 1 - Installation der InfluxDB 2.1
Installieren Sie mit Hilfe eines Docker-Compose-Files die Zeitreihendatenbank InfluxDB 2.1. Geben Sie der InfluxDB die IPv6-Adresse 2001:638:408:200:FC??::12 aus Ihrem Adressraum.
Konfigurieren Sie Ihre InfluxDB 2.1 mit einem ersten Start-Bucket mybucket.
Machen Sie sich mit der Oberfläche Ihrer InfluxDB 2.1 vertraut.
 

## Aufgabe 2 - Einrichten von Telegraf als Datenquelle der InfluxDB
In Praktikumsblatt 3, Aufgabe 1 haben wir auf unserem Server moni21 den Data Exporter Telegraf installiert und so konfiguriert, dass er die CPU-Daten sammelt. Richten Sie Telegraf so ein, dass er die gesammelten CPU-Daten an den Bucket mybucket Ihrer InfluxDB sendet. Geben Sie Ihre Konfigurationsdatei telegraf.conf an.
Mit welchem Protokoll werden die gesammelten Daten versendet? Wie könnte diese Verbindung abgesichert werden?
Fragen Sie mit dem InfluxDB-Data-Explorer die CPU-Zeiten Ihres Servers moni21 im User-Modus ab. Geben Sie den erzeugten Flux-Code der zugehörigen Query an und interpretieren Sie diesen Code.
 

## Aufgabe 3 - Verbinden der InfluxDB mit Grafana
Richten Sie auf Grafana den Zugriff auf die "Data Source" InfluxDB ein. Wählen Sie als Query Sprache Flux. Sobald die grüne Schrift   3 Buckets found   erscheint, haben Sie es geschafft.
Erstellen Sie ein Grafana-Dashboard Praktikumsblatt7 mit folgenden beiden Panels P1 und P2:
P1: CPU-Usermode für Server moni21 mit InfluxDB+Telegraf+Flux.
P2: CPU-Usermode für Server moni21 mit Prometheus+NodeExporter+PromQL.
Vergleichen Sie die beiden Graphen.
Nun soll Last erzeugt werden. Mit dem commando htop können Sie die aktuelle Auslastung Ihrer CPUs überprüfen. Mit dem Kommando
    while : ; do : ; done
erzeugen Sie eine Unendlichschleife, mit der Sie eine CPU auf Ihrem Host voll auslasten (siehe: superuser). Wenn Sie die Schleifen nochmals starten, werden zwei CPUs voll ausgelastet. Testen Sie mit dieser Methode Ihre Panels 1 und 2. Erstellen Sie Snapshots auf dem vergleichende CPU-Messungen dargestellt sind.
Nach Ihren Tests beenden Sie unbedingt die Lasterzeugung!
Beurteilen und bewerten Sie Ihre Ergebnisse?
 

## Aufgabe 4 - Abfrage des Prometheus-Referenz-Exporters
Richten Sie für Ihre InfluxDB einen Datenscraper ReferenzExporter auf den Prometheus-Referenz-Exporter http://dh-ipv6.docklab.de:8777/metrics ein. Der Datenscraper soll die gescrapten Daten in den Bucket mybucket schreiben.
Erweitern Sie Ihr Grafana-Dashboard Praktikumsblatt7 mit folgenden beiden Panels P3 und P4:
P3 zeigt die CPU-Auslastung der virtuellen CPU5 des Prometheus-Referenz-Exporters.
P3 benutzt zur Abfrage und Auswertung der Werte die InfluxDB mit der Abfragesprache Flux.
P4 zeigt ebenfalls die CPU-Auslastung der virtuellen CPU5 des Prometheus-Referenz-Exporter.
P4 jedoch benutzt jedoch zur Abfrage und Auswertung der Werte das System Prometheus mit der Abfragesprache PromQL.
Vergleichen Sie die beiden Graphen. Was beurteilen Sie das Ergebnis?

Mit welcher Flux-Abfrage haben Sie das Panel P4 erzeugt? Erläutern Sie Ihren Code.
